//////////////////////////////////////////////////////////////////////////// 
// 
// Copyright (C) DSTC Pty Ltd (ACN 052 372 577) 1993, 1994, 1995.
// Unpublished work.  All Rights Reserved.
// 
// The software contained on this media is the property of the
// DSTC Pty Ltd.  Use of this software is strictly in accordance
// with the license agreement in the accompanying LICENSE.DOC 
// file. If your distribution of this software does not contain 
// a LICENSE.DOC file then you have no rights to use this 
// software in any manner and should contact DSTC at the address 
// below to determine an appropriate licensing arrangement.
// 
//      DSTC Pty Ltd
//      Level 7, GP South
//      University of Queensland
//      St Lucia, 4072
//      Australia
//      Tel: +61 7 3365 4310
//      Fax: +61 7 3365 4311
//      Email: jcsi@dstc.qut.edu.au
// 
// This software is being provided "AS IS" without warranty of
// any kind.  In no event shall DSTC Pty Ltd be liable for
// damage of any kind arising out of or in connection with
// the use or performance of this software.
// 
//////////////////////////////////////////////////////////////////////////// 

package com.dstc.security.kerberos.v5;

import java.util.Vector;

import com.dstc.security.kerberos.v5.base.*;
import com.dstc.security.kerberos.v5.crypto.EncryptedData;

import com.dstc.security.asn1.Asn1;
import com.dstc.security.asn1.Asn1Exception;
import com.dstc.security.asn1.Explicit;
import com.dstc.security.asn1.Sequence;

/**
 * <p>A class representing the Kerberos ASN.1 structure KRB_CRED.
 *
 * <pre>
 *   KRB_CRED ::=  [APPLICATION 22] SEQUENCE {
 *                   pvno[0]                       INTEGER,
 *                   msg-type[1]                   INTEGER,
 *                   tickets[2]                    SEQUENCE OF Ticket,
 *                   enc-part[3]                   EncryptedData,
 *               }
 * </pre>
 */
public final class KrbCred extends Explicit 
{
  public static final int TAG_KRB_CRED = 22;
  private static final int pvno = 5; // Kerberos version number

  private int msgType = TAG_KRB_CRED;
  private Vector tickets;              
  private EncryptedData encPart; 

  /**
   * Constructs a KrbCred from a Vector of Tickets and an EncryptedData
   * for EncKrbCredPart
   */
  public KrbCred(Vector tickets, EncryptedData encPart)
  {
    super(Asn1.TAG_CLASS_APPLICATION, TAG_KRB_CRED);
    Sequence seq = new Sequence();

    Explicit exp = new Explicit(Asn1.TAG_CLASS_CONTEXT, 0);
    exp.addComponent(new com.dstc.security.asn1.Integer(pvno));
    seq.addComponent(exp);

    exp = new Explicit(Asn1.TAG_CLASS_CONTEXT, 1);
    exp.addComponent(new com.dstc.security.asn1.Integer(msgType));
    seq.addComponent(exp);

    this.tickets = tickets;
    exp = new Explicit(Asn1.TAG_CLASS_CONTEXT, 2);
    exp.addComponent(new TicketsSeq(tickets));
    seq.addComponent(exp);

    this.encPart = encPart;
    exp = new Explicit(Asn1.TAG_CLASS_CONTEXT, 3);
    exp.addComponent(encPart);
    seq.addComponent(exp);

    addComponent(seq);
  }

  /**
   * Constructs an KrbCred from a DER encoding
   */
  public KrbCred(byte[] encoded) 
    throws Asn1Exception, BadVersionException, BadMessageTypeException 
  {
    doDecode(encoded);

    if (this.getTagNumber() != TAG_KRB_CRED)
      throw new BadMessageTypeException("Wrong tag for a KrbCred");

    Sequence seq = (Sequence)this.getComponent();
    Vector comps = seq.getComponents();

    int i = 0;

    Explicit exp = (Explicit)comps.elementAt(i++);
    if (exp.getTagNumber() != 0)
      throw new Asn1Exception("Bad Tag Number");
    if (((com.dstc.security.asn1.Integer)exp.getComponent()).getInt() != pvno)
      throw new BadVersionException("Bad version number");

    exp = (Explicit)comps.elementAt(i++);
    if (exp.getTagNumber() != 1)
      throw new Asn1Exception("Bad Tag number");
    if (((com.dstc.security.asn1.Integer)exp.getComponent()).getInt() 
         !=msgType)
      throw new BadMessageTypeException("Bad msgType for a KrbCred");

    exp = (Explicit)comps.elementAt(i++);
    if (exp.getTagNumber() != 2)
      throw new Asn1Exception("Bad Tag number");
    TicketsSeq ticketsSeq = new TicketsSeq(exp.getComponent().encode());
    this.tickets = ticketsSeq.getTickets();

    exp = (Explicit)comps.elementAt(i++);
    if (exp.getTagNumber() != 3)
      throw new Asn1Exception("Bad Tag number");
    this.encPart = new EncryptedData(exp.getComponent().encode());
  }

  /**
   * Returns the EncryptedData in this KrbCred
   */
  public EncryptedData getEncrypted()
  {
    return this.encPart;
  }

  /**
   * Returns the Vector of Tickets in this KrbCred
   */
  public Vector getTickets()
  {
    return this.tickets;
  }
}
